let app = getApp()
Page({
  data: {
    scores: '',
    qualified: ''
  },
  onLoad(options) {
    this.setData({
      scores: options.scores,
      qualified: options.qualified
    })
  },
  resetAnswer() {
    let that = this
    let content
    if (that.data.qualified == '0') {
      content = "很遗憾！成绩不合格，是否重新本次考试？"
    } else {
      content = "您已合格，重考将覆盖原始记录，是否继续？"
    }
    dd.confirm({
      title: '温馨提示',
      content: content,
      confirmButtonText: '是',
      cancelButtonText: '否',
      success: (result) => {
        if (result.confirm) {
          dd.getStorage({
            key: 'answerid',
            success: function (res) {
              that.retakeExam(res.data.exam_id, res.data.result_id)
            },
            fail: function (res) {
              dd.alert({ content: res.errorMessage });
            }
          });
        }
      },
    });
  },
  retakeExam(exam_id, result_id) {
    let params = {
      result_id: result_id
    }
    app.https('POST', app.globaldata.apiUrl.retakeExam, JSON.stringify(params), {
      type: false
    }).then(res => {
      console.log(res)
      dd.reLaunch({
        url: "../answer/answer?result_id=" + res.data.data.result_id + '&exam_id=' + exam_id
      })

    })
  },
  back() {
    dd.reLaunch({
      url: '../index/index'
    })
  }
});
